diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index a81912b744..1c364c0f54 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -8667,6 +9111,849 @@ XLogAssignLSN(void)
 	return XLogInsert(RM_XLOG_ID, XLOG_ASSIGN_LSN);
 }
 
+/*
+ * Write a WAL record marking the start (XLOG_UPGRADE_START) or completion
+ * (XLOG_UPGRADE_COMPLETE) of pg_upgrade.  These records bracket the
+ * schema-restore window; both markers present means the upgrade was atomic.
+ */
+XLogRecPtr
+XLogWritePgUpgrade(bool is_start, uint32 old_major_version,
+				   uint32 new_major_version)
+{
+	xl_pg_upgrade xlrec;
+	XLogRecPtr	RecPtr;
+
+	/* zero padding and the pg_version tail so no stack bytes leak into WAL */
+	memset(&xlrec, 0, sizeof(xlrec));
+	xlrec.old_major_version = old_major_version;
+	xlrec.new_major_version = new_major_version;
+	xlrec.upgrade_time = (pg_time_t) time(NULL);
+	/* Embed PG_MAJORVERSION so redo can write $PGDATA/PG_VERSION */
+	snprintf(xlrec.pg_version, sizeof(xlrec.pg_version), "%s\n",
+			 PG_MAJORVERSION);
+
+	XLogBeginInsert();
+	XLogRegisterData(&xlrec, SizeOfXLPgUpgrade);
+	RecPtr = XLogInsert(RM_PG_UPGRADE_ID,
+						is_start ? XLOG_UPGRADE_START
+						: XLOG_UPGRADE_COMPLETE);
+
+	if (is_start)
+		ereport(LOG,
+				(errmsg("recorded pg_upgrade start at %X/%X (old major version %u, new major version %u)",
+						LSN_FORMAT_ARGS(RecPtr),
+						old_major_version, new_major_version)));
+	else
+		ereport(LOG,
+				(errmsg("recorded pg_upgrade completion at %X/%X (old major version %u, new major version %u)",
+						LSN_FORMAT_ARGS(RecPtr),
+						old_major_version, new_major_version)));
+
+	return RecPtr;
+}
+
+/*
+ * XLogWritePgUpgradeHandoff -- emit the OLD-format streaming-handoff trigger.
+ *
+ * Called from ShutdownXLOG() on the OLD primary as it shuts down (see
+ * EmitPgUpgradeHandoffIfArmed), so the record is written in the OLD WAL page
+ * format, streamed to a physical standby still following it, and guaranteed to
+ * sit after all user WAL and before the shutdown checkpoint.  See
+ * xl_pg_upgrade_handoff for why this is a separate record from the new-format
+ * XLOG_UPGRADE_START burst.
+ */
+XLogRecPtr
+XLogWritePgUpgradeHandoff(uint32 old_major_version, uint32 target_major_version)
+{
+	xl_pg_upgrade_handoff xlrec;
+	XLogRecPtr	RecPtr;
+
+	/* zero padding so no uninitialized stack bytes leak into WAL */
+	memset(&xlrec, 0, sizeof(xlrec));
+	xlrec.old_major_version = old_major_version;
+	xlrec.target_major_version = target_major_version;
+	xlrec.handoff_time = (pg_time_t) time(NULL);
+
+	XLogBeginInsert();
+	XLogRegisterData(&xlrec, SizeOfXLPgUpgradeHandoff);
+	RecPtr = XLogInsert(RM_PG_UPGRADE_ID, XLOG_UPGRADE_HANDOFF);
+
+	/*
+	 * Flush it: a streaming standby must receive this record before the
+	 * primary shuts down, so it must be on disk, not buffered.
+	 */
+	XLogFlush(RecPtr);
+
+	ereport(LOG,
+			(errmsg("pg_upgrade handoff trigger recorded at %X/%X "
+					"(old major version %u, target major version %u)",
+					LSN_FORMAT_ARGS(RecPtr),
+					old_major_version, target_major_version)));
+
+	return RecPtr;
+}
+
+/*
+ * EmitPgUpgradeHandoffIfArmed -- emit the streaming-handoff trigger at shutdown
+ * if pg_upgrade --wal-upgrade-signal-handoff armed it.
+ *
+ * Called from ShutdownXLOG() on a live primary, before WAL senders stop and
+ * before the shutdown checkpoint.  The sentinel file (written by the pg_upgrade
+ * lifecycle subcommand) holds the target major version.  Absent sentinel is the
+ * common case and a no-op.  The file is removed once consumed so a later restart
+ * does not re-emit.
+ */
+void
+EmitPgUpgradeHandoffIfArmed(void)
+{
+	const char *path = PG_UPGRADE_HANDOFF_SIGNAL_FILE;
+	FILE	   *f;
+	int			target_major = 0;
+
+	f = AllocateFile(path, "r");
+	if (f == NULL)
+	{
+		if (errno != ENOENT)
+			ereport(FATAL,
+					(errcode_for_file_access(),
+					 errmsg("could not open pg_upgrade handoff signal file \"%s\": %m",
+							path)));
+		return;					/* not armed: normal shutdown */
+	}
+
+	if (fscanf(f, "%d", &target_major) != 1 || target_major <= 0)
+	{
+		FreeFile(f);
+		ereport(FATAL,
+				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+				 errmsg("invalid data in pg_upgrade handoff signal file \"%s\"",
+						path)));
+	}
+	FreeFile(f);
+
+	(void) XLogWritePgUpgradeHandoff(PG_VERSION_NUM / 10000,
+									 (uint32) target_major);
+
+	if (unlink(path) != 0)
+		ereport(FATAL,
+				(errcode_for_file_access(),
+				 errmsg("could not remove pg_upgrade handoff signal file \"%s\": %m",
+						path)));
+}
+
+/*
+ * Recursively collect PGDATA-relative subdirectory paths under "abspath"
+ * (relative prefix "relpath"), appending each NUL-terminated to dbuf and
+ * counting them in *ndirs.  Parents are appended before children so a plain
+ * mkdir() per path suffices on replay.
+ *
+ * pg_wal is skipped; the upgrade WAL segments and pg_wal/ are handled by
+ * PerformWalUpgradeIfNeeded(), not by the directory after-image.
+ */
+static void
+CollectUpgradeDirs(const char *abspath, const char *relpath,
+				   StringInfo dbuf, uint32 *ndirs,
+				   StringInfo sbuf, uint32 *nsymlinks)
+{
+	DIR		   *dir;
+	struct dirent *de;
+
+	dir = AllocateDir(abspath);
+	if (dir == NULL)
+		return;
+
+	while ((de = ReadDir(dir, abspath)) != NULL)
+	{
+		char		childabs[MAXPGPATH];
+		char		childrel[MAXPGPATH];
+		struct stat st;
+
+		if (strcmp(de->d_name, ".") == 0 || strcmp(de->d_name, "..") == 0)
+			continue;
+
+		/* top-level pg_wal is not part of the after-image (see comment) */
+		if (relpath[0] == '\0' && strcmp(de->d_name, "pg_wal") == 0)
+			continue;
+
+		/*
+		 * Top-level pg_replslot is not part of the after-image either.  Its
+		 * upgrade-window retention slot has a per-slot "state" file that is
+		 * not WAL-logged, so capturing the directory without it would leave a
+		 * reconstructed cluster with an empty pg_replslot/<slot>/ that PANICs
+		 * at startup.  The slot is a primary-only artifact; a reconstructed
+		 * cluster starts with an empty pg_replslot/, so skip the whole
+		 * subtree.
+		 */
+		if (relpath[0] == '\0' && strcmp(de->d_name, "pg_replslot") == 0)
+			continue;
+
+		snprintf(childabs, sizeof(childabs), "%s/%s", abspath, de->d_name);
+
+		if (relpath[0] == '\0')
+			snprintf(childrel, sizeof(childrel), "%s", de->d_name);
+		else
+			snprintf(childrel, sizeof(childrel), "%s/%s", relpath, de->d_name);
+
+		/*
+		 * A symlink (e.g. pg_tblspc/<spcoid>) is captured as (linkpath,
+		 * target) so replay can recreate it; we do not recurse through it
+		 * (its contents arrive as RELFILE images via smgr once the symlink
+		 * exists).
+		 */
+		if (lstat(childabs, &st) == 0 && S_ISLNK(st.st_mode))
+		{
+			char		target[MAXPGPATH];
+			ssize_t		tlen;
+
+			tlen = readlink(childabs, target, sizeof(target) - 1);
+			if (tlen < 0 || tlen >= (ssize_t) sizeof(target))
+				continue;		/* unreadable / too long -- skip */
+			target[tlen] = '\0';
+
+			appendBinaryStringInfo(sbuf, childrel, strlen(childrel) + 1);
+			appendBinaryStringInfo(sbuf, target, strlen(target) + 1);
+			(*nsymlinks)++;
+			continue;
+		}
+
+		if (lstat(childabs, &st) != 0 || !S_ISDIR(st.st_mode))
+			continue;			/* only directories and symlinks; skip files */
+
+		/* append this directory, then recurse into it (parent-before-child) */
+		appendBinaryStringInfo(dbuf, childrel, strlen(childrel) + 1);
+		(*ndirs)++;
+
+		CollectUpgradeDirs(childabs, childrel, dbuf, ndirs, sbuf, nsymlinks);
+	}
+	FreeDir(dir);
+}
+
+/*
+ * Emit one XLOG_UPGRADE_DIRTREE record capturing the after-image of the new
+ * cluster's directory tree (every subdirectory under PGDATA except pg_wal).
+ * initdb creates this tree outside the server, so it is not otherwise
+ * WAL-logged; this lets recovery rebuild the skeleton from WAL without initdb.
+ *
+ * Emitted right after XLOG_UPGRADE_START and before the file-image records, so
+ * the directories exist before any relfile/SLRU image is replayed into them.
+ */
+XLogRecPtr
+XLogWriteUpgradeDirSkel(void)
+{
+	xl_upgrade_dirtree xlrec;
+	StringInfoData dbuf;		/* directory paths */
+	StringInfoData sbuf;		/* symlink entries */
+	XLogRecPtr	RecPtr;
+
+	/* zero padding so no uninitialized stack bytes leak into WAL */
+	memset(&xlrec, 0, sizeof(xlrec));
+	initStringInfo(&dbuf);
+	initStringInfo(&sbuf);
+	xlrec.ndirs = 0;
+	xlrec.nsymlinks = 0;
+	CollectUpgradeDirs(DataDir, "", &dbuf, &xlrec.ndirs,
+					   &sbuf, &xlrec.nsymlinks);
+	xlrec.dir_bytes = (uint32) dbuf.len;
+	xlrec.sym_bytes = (uint32) sbuf.len;
+
+	XLogBeginInsert();
+	XLogRegisterData(&xlrec, SizeOfXLUpgradeDirtree);
+	if (dbuf.len > 0)
+		XLogRegisterData(dbuf.data, dbuf.len);
+	if (sbuf.len > 0)
+		XLogRegisterData(sbuf.data, sbuf.len);
+	RecPtr = XLogInsert(RM_PG_UPGRADE_ID, XLOG_UPGRADE_DIRTREE);
+
+	ereport(LOG,
+			(errmsg("pg_upgrade directory after-image recorded at %X/%X (%u directories, %u symlinks)",
+					LSN_FORMAT_ARGS(RecPtr), xlrec.ndirs, xlrec.nsymlinks)));
+
+	pfree(dbuf.data);
+	pfree(sbuf.data);
+	return RecPtr;
+}
+
+/*
+ * Emit XLOG_UPGRADE_SLRU_DATA records for all segment files in one SLRU
+ * directory (pg_xact, pg_multixact/offsets, or pg_multixact/members).  These
+ * FPIs are self-contained: redo is the sole writer of these pages, so it just
+ * writes the raw bytes back per segment file.
+ *
+ * Segments are sorted and packed into records covering contiguous runs
+ * [first_seg, last_seg] to minimise record count.  Returns the LSN of the last
+ * record, or InvalidXLogRecPtr if the directory is empty.
+ */
+XLogRecPtr
+XLogWriteUpgradeSlruData(uint8 slru_type)
+{
+	const char *slru_dirs[] = UPGRADE_SLRU_DIRS;
+	const char *slru_dir;
+	DIR		   *dir;
+	struct dirent *de;
+	XLogRecPtr	lsn = InvalidXLogRecPtr;
+
+	/* sorted list of (seg_number, filepath) pairs */
+	typedef struct
+	{
+		int64		segno;
+		char		path[MAXPGPATH];
+	} SlruSegInfo;
+
+	SlruSegInfo *segs = NULL;
+	int			nsegs = 0;
+	int			segs_alloc = 0;
+	int			i;
+
+	/*
+	 * Max segments per WAL record.  Reserve headroom for the
+	 * xl_upgrade_slru_data header and the XLogRecord header so a full batch's
+	 * data plus those headers still fits under XLogRecordMaxSize; otherwise a
+	 * contiguous run of exactly XLogRecordMaxSize/seg_size segments would
+	 * produce a record that XLogInsert() rejects as oversized.  (Mirrors the
+	 * relfile batch cap's headroom.)
+	 */
+	Size		seg_size = SLRU_PAGES_PER_SEGMENT * BLCKSZ;
+	int			max_segs_per_rec =
+		(int) ((XLogRecordMaxSize - SizeOfXLUpgradeSlruData - SizeOfXLogRecord)
+			   / seg_size);
+
+	if (slru_type >= lengthof(slru_dirs))
+		elog(ERROR, "invalid slru_type %u", slru_type);
+
+	slru_dir = slru_dirs[slru_type];
+
+	/* --- Pass 1: collect and sort segment numbers --- */
+	dir = AllocateDir(slru_dir);
+	if (dir == NULL)
+		return InvalidXLogRecPtr;
+
+	while ((de = ReadDir(dir, slru_dir)) != NULL)
+	{
+		int64		segno;
+		size_t		len = strlen(de->d_name);
+
+		if (de->d_name[0] == '.')
+			continue;
+
+		/*
+		 * Parse the FULL hex segment name, mirroring SlruScanDirectory() in
+		 * slru.c.  A capped read (e.g. "%04") would truncate long (15-digit)
+		 * or high-count (5-6 digit) names to a wrong segment number and
+		 * install the pages at the wrong offset.  Accept only all-hex names.
+		 */
+		if (strspn(de->d_name, "0123456789ABCDEF") != len)
+			continue;
+		segno = strtoi64(de->d_name, NULL, 16);
+
+		if (nsegs >= segs_alloc)
+		{
+			segs_alloc = (segs_alloc == 0) ? 64 : segs_alloc * 2;
+			if (segs == NULL)
+				segs = palloc_array(SlruSegInfo, segs_alloc);
+			else
+				segs = repalloc_array(segs, SlruSegInfo, segs_alloc);
+		}
+		segs[nsegs].segno = segno;
+		snprintf(segs[nsegs].path, MAXPGPATH, "%s/%s", slru_dir, de->d_name);
+		nsegs++;
+	}
+	FreeDir(dir);
+
+	if (nsegs == 0)
+	{
+		if (segs)
+			pfree(segs);
+		return InvalidXLogRecPtr;
+	}
+
+	/* sort ascending by segment number */
+	{
+		int			k,
+					n = nsegs;
+
+		/* simple insertion sort -- segment count is typically small */
+		for (k = 1; k < n; k++)
+		{
+			SlruSegInfo tmp = segs[k];
+			int			m = k;
+
+			while (m > 0 && segs[m - 1].segno > tmp.segno)
+			{
+				segs[m] = segs[m - 1];
+				m--;
+			}
+			segs[m] = tmp;
+		}
+	}
+
+	/* --- Pass 2: pack consecutive segments per record, allocate exact size --- */
+	i = 0;
+	while (i < nsegs)
+	{
+		xl_upgrade_slru_data xlrec;
+		int			j;
+		int			batch_count;
+		Size		batch_bytes;
+		char	   *packbuf;
+
+		/* Determine how many consecutive segments go in this batch */
+		j = i;
+		while (j < nsegs &&
+			   (j - i) < max_segs_per_rec &&
+			   (j == i || segs[j].segno == segs[j - 1].segno + 1))
+			j++;
+
+		batch_count = j - i;
+		batch_bytes = (Size) batch_count * seg_size;
+
+		/* Allocate exactly the batch size, not a worst-case buffer. */
+		packbuf = palloc(batch_bytes);
+
+		/* Read each segment file into the pack buffer */
+		for (int k = 0; k < batch_count; k++)
+		{
+			int			fd;
+			ssize_t		nbytes;
+
+			char	   *segbuf = packbuf + (Size) k * seg_size;
+			Size		total = 0;
+
+			fd = OpenTransientFile(segs[i + k].path, O_RDONLY | PG_BINARY);
+			if (fd < 0)
+				ereport(ERROR,
+						(errcode_for_file_access(),
+						 errmsg("could not open SLRU file \"%s\": %m",
+								segs[i + k].path)));
+
+			/*
+			 * Read the whole segment.  read() may return a short count
+			 * without reaching EOF (e.g. interrupted after a partial
+			 * transfer), so loop: only a return of 0 is genuine EOF.  A
+			 * segment that ends before seg_size is a legitimately-partial
+			 * final segment; zero-pad its remainder so redo can stride by
+			 * seg_size.  Treating any short read as EOF would zero-fill the
+			 * tail of a full interior segment and corrupt it (for pg_xact,
+			 * silently losing commit status).
+			 */
+			for (;;)
+			{
+				nbytes = read(fd, segbuf + total, seg_size - total);
+				if (nbytes < 0)
+				{
+					CloseTransientFile(fd);
+					ereport(ERROR,
+							(errcode_for_file_access(),
+							 errmsg("could not read SLRU file \"%s\": %m",
+									segs[i + k].path)));
+				}
+				if (nbytes == 0)
+					break;		/* EOF */
+				total += (Size) nbytes;
+				if (total >= seg_size)
+					break;
+			}
+			CloseTransientFile(fd);
+
+			/* pad a genuinely-short (final) segment to full size */
+			if (total < seg_size)
+				memset(segbuf + total, 0, seg_size - total);
+		}
+
+		/* zero padding so no uninitialized stack bytes leak into WAL */
+		memset(&xlrec, 0, sizeof(xlrec));
+		xlrec.slru_type = slru_type;
+		xlrec.first_seg = segs[i].segno;
+		xlrec.last_seg = segs[i + batch_count - 1].segno;
+		xlrec.total_bytes = (uint32) batch_bytes;
+
+#ifdef USE_ASSERT_CHECKING
+
+		/*
+		 * Fault-injection hook: inflate total_bytes past the payload actually
+		 * registered below, producing a valid-CRC but internally inconsistent
+		 * record that exercises pg_upgrade_redo's SLRU bounds check.  Gated
+		 * on USE_ASSERT_CHECKING so a production build never emits such a
+		 * record.
+		 */
+		if (getenv("PG_UPGRADE_TEST_CORRUPT_SLRU_LEN") != NULL)
+			xlrec.total_bytes = (uint32) (batch_bytes + seg_size);
+#endif
+
+		XLogBeginInsert();
+		XLogRegisterData(&xlrec, SizeOfXLUpgradeSlruData);
+		XLogRegisterData(packbuf, batch_bytes);
+		lsn = XLogInsert(RM_PG_UPGRADE_ID, XLOG_UPGRADE_SLRU_DATA);
+
+		pfree(packbuf);
+		i = j;
+	}
+
+	pfree(segs);
+	return lsn;
+}
+
+/*
+ * Batched emission of XLOG_UPGRADE_RELFILE_DATA.  These FPIs are
+ * self-contained: redo is the sole writer of these relation-file pages.  Many
+ * chunks are packed into one record to use the coarsest WAL granularity:
+ *
+ *     UpgradeRelfileBatch b;
+ *     XLogUpgradeRelfileBatchBegin(&b);
+ *     for each file: XLogUpgradeRelfileBatchAddFile(&b, path, ...);
+ *     XLogUpgradeRelfileBatchEnd(&b);
+ *
+ * The batch is capped a little below XLogRecordMaxSize to leave room for the
+ * XLogRecord header; a single chunk never exceeds cap minus one entry header,
+ * so after a flush any chunk fits.
+ */
+#define UPGRADE_RELFILE_BATCH_CAP \
+	((Size) ((XLogRecordMaxSize / BLCKSZ - 2) * (Size) BLCKSZ))
+#define UPGRADE_RELFILE_MAX_CHUNK \
+	((Size) (((UPGRADE_RELFILE_BATCH_CAP - SizeOfXLUpgradeRelfileEntry) / BLCKSZ) * (Size) BLCKSZ))
+
+/*
+ * Flush the accumulated batch as one WAL record of type "info"
+ * (XLOG_UPGRADE_RELFILE_DATA for the relfile batch, XLOG_UPGRADE_RELINK for the
+ * relink manifest -- both accumulate into UpgradeRelfileBatch the same way).
+ */
+static void
+XLogUpgradeBatchFlush(UpgradeRelfileBatch *b, uint8 info)
+{
+	if (b->used == 0)
+		return;
+
+	XLogBeginInsert();
+	XLogRegisterData(b->buf, b->used);
+	XLogInsert(RM_PG_UPGRADE_ID, info);
+
+	b->nrecords++;
+	b->used = 0;
+	b->nentries = 0;
+}
+
+void
+XLogUpgradeRelfileBatchBegin(UpgradeRelfileBatch *b)
+{
+	b->buf = palloc(UPGRADE_RELFILE_BATCH_CAP);
+	b->cap = UPGRADE_RELFILE_BATCH_CAP;
+	b->used = 0;
+	b->nentries = 0;
+	b->nrecords = 0;
+	b->nfiles = 0;
+}
+
+/*
+ * Add every chunk of one relation file segment to the batch, flushing full
+ * records as we go.  A missing or empty file is silently skipped.
+ */
+void
+XLogUpgradeRelfileBatchAddFile(UpgradeRelfileBatch *b, const char *path,
+							   Oid tsoid, Oid dboid, RelFileNumber rfnum,
+							   uint8 forknum, uint32 segno)
+{
+	struct stat stbuf;
+	int			fd;
+	Size		filesize;
+	Size		off;
+
+	if (stat(path, &stbuf) != 0)
+	{
+		if (errno == ENOENT)
+			return;
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not stat \"%s\": %m", path)));
+	}
+
+	filesize = (Size) stbuf.st_size;
+
+	/*
+	 * An empty (0-byte) relation file still needs a record so replay
+	 * recreates it; otherwise the first write to an empty system catalog
+	 * fails with "could not open file".  Emit a zero-page entry (nbytes=0);
+	 * RELFILE redo creates the file via smgr without writing any page.  Only
+	 * the base segment (segno 0) needs this; higher segments are never empty.
+	 */
+	if (filesize == 0)
+	{
+		xl_upgrade_relfile_entry ent;
+
+		if (segno != 0)
+			return;				/* an empty non-base segment: nothing to
+								 * create */
+
+		if (b->used + SizeOfXLUpgradeRelfileEntry > b->cap)
+			XLogUpgradeBatchFlush(b, XLOG_UPGRADE_RELFILE_DATA);
+
+		memset(&ent, 0, sizeof(ent));
+		ent.tablespace_oid = tsoid;
+		ent.database_oid = dboid;
+		ent.relfilenumber = rfnum;
+		ent.forknum = forknum;
+		ent.segno = segno;
+		ent.blockoff = 0;
+		ent.nbytes = 0;			/* signals "create empty file, no pages" */
+
+		memcpy(b->buf + b->used, &ent, SizeOfXLUpgradeRelfileEntry);
+		b->used += SizeOfXLUpgradeRelfileEntry;
+		b->nentries++;
+		b->nfiles++;
+		return;
+	}
+
+	fd = OpenTransientFile(path, O_RDONLY | PG_BINARY);
+	if (fd < 0)
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not open \"%s\": %m", path)));
+
+	for (off = 0; off < filesize; off += UPGRADE_RELFILE_MAX_CHUNK)
+	{
+		Size		chunk = Min(UPGRADE_RELFILE_MAX_CHUNK, filesize - off);
+		xl_upgrade_relfile_entry ent;
+		ssize_t		nread;
+
+		/* Start a fresh record if this entry would overflow the batch. */
+		if (b->used + SizeOfXLUpgradeRelfileEntry + chunk > b->cap)
+			XLogUpgradeBatchFlush(b, XLOG_UPGRADE_RELFILE_DATA);
+
+		/* zero the struct so its alignment padding is never uninitialized WAL */
+		memset(&ent, 0, sizeof(ent));
+		ent.tablespace_oid = tsoid;
+		ent.database_oid = dboid;
+		ent.relfilenumber = rfnum;
+		ent.forknum = forknum;
+		ent.segno = segno;
+		ent.blockoff = (uint32) (off / BLCKSZ);
+		ent.nbytes = (uint32) chunk;
+
+		memcpy(b->buf + b->used, &ent, SizeOfXLUpgradeRelfileEntry);
+		b->used += SizeOfXLUpgradeRelfileEntry;
+
+		nread = pg_pread(fd, b->buf + b->used, chunk, off);
+		if (nread != (ssize_t) chunk)
+		{
+			CloseTransientFile(fd);
+			ereport(ERROR,
+					(errcode_for_file_access(),
+					 errmsg("could not read \"%s\": %m", path)));
+		}
+		b->used += chunk;
+		b->nentries++;
+	}
+
+	CloseTransientFile(fd);
+	b->nfiles++;
+}
+
+void
+XLogUpgradeRelfileBatchEnd(UpgradeRelfileBatch *b)
+{
+	XLogUpgradeBatchFlush(b, XLOG_UPGRADE_RELFILE_DATA);
+	pfree(b->buf);
+	b->buf = NULL;
+
+	ereport(LOG,
+			(errmsg("pg_upgrade captured %d relation files in %d WAL record(s)",
+					b->nfiles, b->nrecords)));
+}
+
+/*
+ * Batched emission of XLOG_UPGRADE_RELINK -- the manifest of user relation
+ * files the window omits.  Each entry is a fixed-size identity; no file data.
+ * Redo links each from the standby's old datadir into the new skeleton.
+ *
+ * Uses the same payload cap as the relfile batch (UPGRADE_RELFILE_BATCH_CAP):
+ * both accumulate into the same WAL-record payload limit.
+ */
+void
+XLogUpgradeRelinkBatchBegin(UpgradeRelfileBatch *b, uint8 xfer_mode)
+{
+	b->buf = palloc(UPGRADE_RELFILE_BATCH_CAP);
+	b->cap = UPGRADE_RELFILE_BATCH_CAP;
+	b->used = 0;
+	b->nentries = 0;
+	b->nrecords = 0;
+	b->nfiles = 0;
+	b->xfer_mode = xfer_mode;
+}
+
+void
+XLogUpgradeRelinkBatchAdd(UpgradeRelfileBatch *b, Oid tsoid, Oid dboid,
+						  RelFileNumber rfnum, uint8 forknum, uint32 segno)
+{
+	xl_upgrade_relink_entry ent;
+
+	if (b->used + SizeOfXLUpgradeRelinkEntry > b->cap)
+		XLogUpgradeBatchFlush(b, XLOG_UPGRADE_RELINK);
+
+	/* zero the struct so alignment padding is never uninitialized WAL */
+	memset(&ent, 0, sizeof(ent));
+	ent.tablespace_oid = tsoid;
+	ent.database_oid = dboid;
+	ent.relfilenumber = rfnum;
+	ent.forknum = forknum;
+	ent.transfer_mode = b->xfer_mode;
+	ent.segno = segno;
+
+	memcpy(b->buf + b->used, &ent, SizeOfXLUpgradeRelinkEntry);
+	b->used += SizeOfXLUpgradeRelinkEntry;
+	b->nentries++;
+	b->nfiles++;
+}
+
+void
+XLogUpgradeRelinkBatchEnd(UpgradeRelfileBatch *b)
+{
+	XLogUpgradeBatchFlush(b, XLOG_UPGRADE_RELINK);
+	pfree(b->buf);
+	b->buf = NULL;
+
+	ereport(LOG,
+			(errmsg("pg_upgrade recorded %d user relation files to relink in %d WAL record(s)",
+					b->nfiles, b->nrecords)));
+}
+
+/*
+ * Emit XLOG_UPGRADE_RAWFILE -- a verbatim image of a non-relation file
+ * (pg_filenode.map, PG_VERSION) so the cluster can be rebuilt from an empty
+ * data directory.  "path" is the PGDATA-relative path.  Returns the record LSN,
+ * or InvalidXLogRecPtr if the file is absent or empty.
+ */
+XLogRecPtr
+XLogWriteUpgradeRawFile(const char *path)
+{
+	xl_upgrade_rawfile xlrec;
+	struct stat stbuf;
+	int			fd;
+	char	   *buf;
+	ssize_t		nbytes;
+	uint32		path_len = (uint32) strlen(path);
+	XLogRecPtr	lsn;
+
+	if (stat(path, &stbuf) != 0)
+	{
+		if (errno == ENOENT)
+			return InvalidXLogRecPtr;
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not stat \"%s\": %m", path)));
+	}
+
+	if (stbuf.st_size == 0)
+		return InvalidXLogRecPtr;
+
+	if ((Size) stbuf.st_size + path_len + SizeOfXLUpgradeRawfile > XLogRecordMaxSize)
+		ereport(ERROR,
+				(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
+				 errmsg("file \"%s\" is too large to capture in a pg_upgrade WAL record",
+						path)));
+
+	buf = palloc(stbuf.st_size);
+
+	fd = OpenTransientFile(path, O_RDONLY | PG_BINARY);
+	if (fd < 0)
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not open \"%s\": %m", path)));
+	nbytes = read(fd, buf, stbuf.st_size);
+	CloseTransientFile(fd);
+	if (nbytes != stbuf.st_size)
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not read \"%s\": %m", path)));
+
+	/* zero padding so no uninitialized stack bytes leak into WAL */
+	memset(&xlrec, 0, sizeof(xlrec));
+	xlrec.path_len = path_len;
+	xlrec.data_len = (uint32) nbytes;
+
+	XLogBeginInsert();
+	XLogRegisterData(&xlrec, SizeOfXLUpgradeRawfile);
+	XLogRegisterData(unconstify(char *, path), path_len);
+	XLogRegisterData(buf, nbytes);
+	lsn = XLogInsert(RM_PG_UPGRADE_ID, XLOG_UPGRADE_RAWFILE);
+
+	pfree(buf);
+	return lsn;
+}
+
+/*
+ * Flush all SLRU (CLOG, commit-ts, multixact) dirty pages to disk and fsync
+ * their segment files, so the SLRU_DATA images captured by the upgrade window
+ * read the final on-disk state.  pg_upgrade runs the burst server with the
+ * SLRU-related pages possibly still dirty in the buffers, and (on some paths)
+ * with dirty OS-cache writes not yet synced, so:
+ *
+ *   - CheckPointCLOG/CheckPointCommitTs/CheckPointMultiXact write out the
+ *     dirty SLRU buffers to the segment files, and
+ *   - the fsync loop below durably syncs those segment files and their parent
+ *     directories.
+ *
+ * This does not request a checkpoint.  CN (the recovery anchor) is the
+ * DB_SHUTDOWNED checkpoint pg_resetwal wrote before the burst server started
+ * and already precedes XLOG_UPGRADE_START; a checkpoint record here would
+ * displace it as the last checkpoint before START.  So the SLRUs are flushed
+ * directly rather than through RequestCheckpoint().
+ */
+void
+XLogFlushUpgradeSLRU(void)
+{
+	/*
+	 * the same SLRU flush steps CheckPointGuts() performs, minus the
+	 * checkpoint
+	 */
+	CheckPointCLOG();
+	CheckPointCommitTs();
+	CheckPointMultiXact();
+
+	/*
+	 * Fsync all SLRU segment files and their parent directories to catch
+	 * evicted pages whose OS-cache writes were not synced under fsync=off.
+	 */
+	{
+		static const char *const slru_dirs[] = UPGRADE_SLRU_DIRS;
+		int			i;
+
+		for (i = 0; i < lengthof(slru_dirs); i++)
+		{
+			DIR		   *dir;
+			struct dirent *de;
+
+			dir = AllocateDir(slru_dirs[i]);
+			if (dir == NULL)
+				continue;
+
+			while ((de = ReadDir(dir, slru_dirs[i])) != NULL)
+			{
+				char		path[MAXPGPATH];
+
+				if (de->d_name[0] == '.')
+					continue;
+
+				/*
+				 * SLRU segment names are short UPPERCASE hex strings (see
+				 * SlruFileName / SlruScanDirectory), not WAL names.
+				 */
+				if (strlen(de->d_name) > 8)
+					continue;
+				if (strspn(de->d_name, "0123456789ABCDEF") != strlen(de->d_name))
+					continue;
+
+				snprintf(path, sizeof(path), "%s/%s",
+						 slru_dirs[i], de->d_name);
+
+				/* fsync_fname ignores enableFsync; forces actual kernel sync */
+				(void) fsync_fname(path, false);
+			}
+			FreeDir(dir);
+
+			/* also fsync the directory itself */
+			(void) fsync_fname(slru_dirs[i], true);
+		}
+	}
+}
+
 /*
  * Check if any of the GUC parameters that are critical for hot standby
  * have changed, and update the value in pg_control file if necessary.
